apiVersion: yaook.cloud/v1
kind: NovaDeployment
metadata:
  name: nova
  namespace: yaook
spec:
  eviction: {}
  keystoneRef:
    name: keystone
  database:
    api:
      replicas: 3
      proxy: 
        replicas: 3
      storageClassName: csi-driver-lvm-linear
      storageSize: 10Gi
      backup:
        schedule: "0 * * * *"
      mysqlConfig:
        mysqld:
          max_allowed_packet: 256M
          max_connections: 4096
          max_heap_table_size: 64M
          expire_logs_days: 2
    placement:
      replicas: 3
      proxy: 
        replicas: 3
      storageClassName: csi-driver-lvm-linear
      storageSize: 15Gi
      backup:
        schedule: "0 * * * *"
      mysqlConfig:
        mysqld:
          max_allowed_packet: 256M
          max_connections: 4096
          max_heap_table_size: 64M
          expire_logs_days: 2
    cell0:
      replicas: 3
      proxy: 
        replicas: 3
      storageClassName: csi-driver-lvm-linear
      storageSize: 20Gi
      backup:
        schedule: "0 * * * *"
      mysqlConfig:
        mysqld:
          max_allowed_packet: 256M
          max_connections: 4096
          max_heap_table_size: 64M
          expire_logs_days: 2
        galera:
          wsrep_slave_threads: 3
    cell1:
      replicas: 3
      proxy: 
        replicas: 3
      storageClassName: csi-driver-lvm-linear
      storageSize: 20Gi
      backup:
        schedule: "0 * * * *"
      mysqlConfig:
        mysqld:
          max_allowed_packet: 256M
          max_connections: 4096
          max_heap_table_size: 64M
          expire_logs_days: 2
  messageQueue:
    cell1:
      replicas: 3
      storageClassName: csi-driver-lvm-linear
      storageSize: 10Gi
  memcached: {}
  api:
    replicas: 3
    ingress:
      fqdn: "{{ fqdn_nova }}"
      port: 443
      #externalCertificateSecretRef:
      # name: compute-api-external-certificate
  conductor:
    replicas: 3
  placement:
    replicas: 3
    ingress:
      fqdn: "{{ fqdn_placement }}"
      port: 443
      #externalCertificateSecretRef:
      #  name: placement-api-external-certificate
  scheduler:
    replicas: 3
  consoleauth:
    replicas: 3
  vnc:
    ingress:
      fqdn: "{{ fqdn_vnc }}"
      port: 443
#      externalCertificateSecretRef:
#        name: vnc-api-external-certificate
    replicas: 3
  metadata:
    replicas: 3
  targetRelease: zed
  novaConfig:
    DEFAULT:
      debug: False
      enable_instance_password: False
      initial_cpu_allocation_ratio: 1.0
      initial_ram_allocation_ratio: 1.0
      initial_disk_allocation_ratio: 1.0
      metadata_workers: 8
      osapi_compute_workers: 8
      instance_usage_audit: True
      instance_usage_audit_period: hour
    notifications:
      notify_on_state_change: vm_and_task_state
    oslo_messaging_notifications:
      driver:
      - messagingv2
    placement:
      os_region_name: {{ region_name }}
    glance:
      verify_glance_signatures: True
    conductor:
      workers: 8
    scheduler:
      workers: 8
    oslo_messaging_rabbit:
      # https://docs.openstack.org/nova/zed/configuration/config.html#oslo-messaging-rabbit
      # rabbit_quorum_queue is true by default in Yaook
      heartbeat_in_pthread: false
      heartbeat_rate: 3  # https://review.opendev.org/c/openstack/oslo.messaging/+/875615
  compute:
    configTemplates:
    - nodeSelectors:
      - matchLabels: {}
      novaComputeConfig:
        DEFAULT:
          debug: False
          source_is_ipv6: True
          enable_instance_password: False
          cpu_allocation_ratio: 1.0
          ram_allocation_ratio: 1.0
          disk_allocation_ratio: 1.0
          instance_usage_audit: True
          instance_usage_audit_period: hour
        notifications:
          notify_on_state_change: vm_and_task_state
        oslo_messaging_notifications:
          driver:
          - messagingv2
        keystone_authtoken:
          os_region_name: {{ region_name }}
        os_vif_ovs:
          ovsdb_connection: unix:/run/openvswitch/db.sock
      volumeBackends:
        ceph:
          enabled: True
          keyringSecretName: rook-ceph-client-a.cinder
          user: a.cinder
          uuid: "ac8ecbc3-97ba-4317-843e-d1f9717cab59"
          cephConfig:
            global:
              "mon_host": "{% for ip in ceph_monitors %}{% if ':' in ip %}[{{ ip }}]:6789{% else %}{{ ip }}:6789{% endif %}{% if not loop.last %},{% endif %}{% endfor %}"
    - nodeSelectors:
      - matchLabels:
          "compute.yaook.cloud/hypervisor-type": "kvm"
      novaComputeConfig:
        libvirt:
          virt_type: kvm
          inject_password: False
          inject_key: False
          inject_partition: -2
  region:
    name: {{ region_name }}
  databaseCleanup:
    schedule: "0 0 * * *"
    deletionTimeRange: 60
  issuerRef:
    name: ca-issuer
